#define PLUGIN_NAME "test Spawn Survivor Bots native"
#define PLUGIN_AUTHOR "Shadowysn"
#define PLUGIN_DESC "Spawn survivor bots with sm_testsurvbot"
#define PLUGIN_VERSION "nil"
#define PLUGIN_URL ""
#define PLUGIN_NAME_SHORT "Spawn Survivor Bots nativetest"
#define PLUGIN_NAME_TECH "nativetest"

#include <sourcemod>
#include <sdktools>

#define REQUIRE_PLUGIN
#include <l4d2_spawnSurvBotsHack>
#undef REQUIRE_PLUGIN

//#include <sdkhooks>
//#include <adminmenu>

#pragma semicolon 1
#pragma newdecls required

#define TEAM_SURVIVOR 2
#define TEAM_PASSING 4

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	EngineVersion ev = GetEngineVersion();
	if (ev == Engine_Left4Dead2)
	{
		return APLRes_Success;
	}
	strcopy(error, err_max, "Plugin only supports Left 4 Dead 2.");
	return APLRes_SilentFailure;
}

public Plugin myinfo =
{
	name = PLUGIN_NAME,
	author = PLUGIN_AUTHOR,
	description = PLUGIN_DESC,
	version = PLUGIN_VERSION,
	url = PLUGIN_URL
}

public void OnPluginStart()
{
	RegAdminCmd("sm_testsurvbot", Command_SpawnSurvBot, ADMFLAG_CHEATS, "sm_testsurvbot <char> <team> - Spawn a survivor bot.");
}

Action Command_SpawnSurvBot(int client, int args)
{
	if (GetClientCount(false) >= MaxClients - 1)
	{
        return Plugin_Handled;
    }
	if (args > 3)
	{
		ReplyToCommand(client, "[SM] Usage: sm_testsurvbot <char> <team>");
		return Plugin_Handled;
	}
	
	char argStr[2];
	int argChar_int, argTeam_int, argSurvSet_int;
	if (args >= 1)
	{
		GetCmdArg(1, argStr, sizeof(argStr));
		argChar_int = StringToInt(argStr);
		if (argChar_int == 0 && argStr[0] != '0') argChar_int = -1;
	}
	if (args >= 2)
	{
		GetCmdArg(2, argStr, sizeof(argStr));
		argTeam_int = StringToInt(argStr);
	}
	if (args >= 3)
	{
		GetCmdArg(3, argStr, sizeof(argStr));
		argSurvSet_int = StringToInt(argStr);
	}
	
	float origin[3];
	origin = view_as<float>({0.0, 0.0, 0.0});
	if (IsValidClient(client))
	{
		GetClientAbsOrigin(client, origin);
	}
	else
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (!IsValidClient(i, true, true) || !IsPlayerAlive(i) || (!IsSurvivor(i) && !IsPassingSurvivor(i))) continue;
			
			GetClientAbsOrigin(i, origin);
			break;
		}
	}
	
	if (argChar_int != 0 || argTeam_int != 0 || argSurvSet_int != 0)
	{ L4D2_CreateSurvivorBot_Hack(origin, argChar_int, argTeam_int, argSurvSet_int); }
	else
	{ L4D2_CreateSurvivorBot_Hack(origin); PrintToServer("Spawning without optional params!"); }
	return Plugin_Handled;
}

stock bool IsSurvivor(int client)
{ return (GetClientTeam(client) == TEAM_SURVIVOR || GetClientTeam(client) == TEAM_PASSING); }

stock bool IsPassingSurvivor(int client)
{ return (GetClientTeam(client) == TEAM_PASSING); }

stock bool RealValidEntity(int entity)
{ return (entity > 0 && IsValidEntity(entity)); }

stock bool IsValidClient(int client, bool replaycheck = true, bool isLoop = false)
{
	if ((isLoop || client > 0 && client <= MaxClients) && IsClientInGame(client))
	{
		if (HasEntProp(client, Prop_Send, "m_bIsCoaching")) // TF2, CSGO?
			if (view_as<bool>(GetEntProp(client, Prop_Send, "m_bIsCoaching"))) return false;
		if (replaycheck)
		{
			if (IsClientSourceTV(client) || IsClientReplay(client)) return false;
		}
		return true;
	}
	return false;
}