#define PLUGIN_NAME "[L4D2] Spawn Survivor Bots Command (NOT A BOT MANAGER)"
#define PLUGIN_AUTHOR "Shadowysn"
#define PLUGIN_DESC "Spawn survivor bots with sm_survbot. Contains a native for use by other plugins."
#define PLUGIN_VERSION "1.0.4b"
#define PLUGIN_URL "https://forums.alliedmods.net/showthread.php?t=335028"
#define PLUGIN_NAME_SHORT "Spawn Survivor Bots Command"
#define PLUGIN_NAME_TECH "spawn_survbot"

#include <sourcemod>
#include <sdktools>
//#include <sdkhooks>
//#include <adminmenu>

#pragma semicolon 1
#pragma newdecls required

#define TEAM_SURVIVOR 2
#define TEAM_PASSING 4

#define SURVBOTS_L4D1				(1 << 0)
#define SURVBOTS_L4D2				(1 << 1)
#define SURVBOTS_PASSING_L4D1		(1 << 2)

#define AUTOEXEC_CFG "l4d2_spawnSurvBotsHack"

static char survivor_names[8][] = { "Nick", "Rochelle", "Coach", "Ellis", "Bill", "Zoey", "Francis", "Louis"};
static char survivor_mdls[8][] = { "gambler", "producer", "coach", "mechanic", "namvet", "teenangst", "biker", "manager"};

public APLRes AskPluginLoad2(Handle myself, bool late, char[] error, int err_max)
{
	EngineVersion ev = GetEngineVersion();
	if (ev == Engine_Left4Dead2)
	{
		RegPluginLibrary("l4d2_spawnSurvBotsHack");
		CreateNative("L4D2_CreateSurvivorBot_Hack", CreateSurvivorBot_Hack);
		return APLRes_Success;
	}
	strcopy(error, err_max, "Plugin only supports Left 4 Dead 2.");
	return APLRes_SilentFailure;
}

ConVar cvarTempBots = null;
//static ConVar cvarEnforceSet = null;
bool g_bTempBots;
//bool g_bEnforceSet;

public Plugin myinfo =
{
	name = PLUGIN_NAME,
	author = PLUGIN_AUTHOR,
	description = PLUGIN_DESC,
	version = PLUGIN_VERSION,
	url = PLUGIN_URL
}

#define PREVENTSELECT_OFF 0
#define PREVENTSELECT_DEFAULT 1
#define PREVENTSELECT_ISBILL 2
#define PREVENTSELECT_ISNICK 3
int g_stored[MAXPLAYERS + 1] = { PREVENTSELECT_OFF };
bool g_isTempBot[MAXPLAYERS + 1] =  { false };

public void OnPluginStart()
{
	// TODO: Find a way to detect old plugin l4d2_spawn_surv_bots.smx,
	// and notify about it and refuse to load
	char desc_str[64];
	Format(desc_str, sizeof(desc_str), "%s version.", PLUGIN_NAME_SHORT);
	char cmd_str[64];
	Format(cmd_str, sizeof(cmd_str), "sm_%s_version", PLUGIN_NAME_TECH);
	ConVar version_cvar = CreateConVar(cmd_str, PLUGIN_VERSION, desc_str, FCVAR_NOTIFY|FCVAR_REPLICATED|FCVAR_DONTRECORD);
	if (version_cvar != null)
		SetConVarString(version_cvar, PLUGIN_VERSION);
	
	Format(cmd_str, sizeof(cmd_str), "sm_%s_temp", PLUGIN_NAME_TECH);
	cvarTempBots = CreateConVar(cmd_str, "0.0", "Kick the Command-spawned bots as soon as they die.", FCVAR_NONE, true, 0.0, true, 1.0);
	
	//Format(cmd_str, sizeof(cmd_str), "sm_%s_missionset", PLUGIN_NAME_TECH);
	//cvarEnforceSet = CreateConVar(cmd_str, "0.0", "Only spawn the L4D1 survivors when L4D1 survivor set is active?", FCVAR_NONE, true, 0.0, true, 1.0);
	
	cvarTempBots.AddChangeHook(ConVarChanged_Cvars);
	//cvarEnforceSet.AddChangeHook(ConVarChanged_Cvars);
	
	AutoExecConfig(true, AUTOEXEC_CFG);
	GetCvars();
	
	HookEvent("player_death", player_death, EventHookMode_Post);
	
	RegAdminCmd("sm_survbot", Command_SpawnSurvBot, ADMFLAG_CHEATS, "sm_survbot <char> <team> - Spawn a survivor bot.");
	RegAdminCmd("sm_fakebot", Command_SpawnFake, ADMFLAG_ROOT, "sm_fakebot <char> <team> - Spawn a survivor bot from CreateFakeClient.");
}

#define smxFileName1 "l4d2_spawn_surv_bots.smx"

public void OnAllPluginsLoaded()
{
	Handle hOldPlugin = FindPluginByFile(smxFileName1);
	if (hOldPlugin) SetFailState("OLD VERSION DETECTED! Please remove %s before using this plugin!", smxFileName1);
}

public void OnPluginEnd()
{
	UnhookEvent("player_death", player_death, EventHookMode_Post);
}

void ConVarChanged_Cvars(Handle convar, const char[] oldValue, const char[] newValue)
{
	GetCvars();
}
void GetCvars()
{
	g_bTempBots = cvarTempBots.BoolValue;
	//g_bEnforceSet = cvarEnforceSet.BoolValue;
}

void player_death(Event event, const char[] name, bool dontBroadcast)
{
	int userid = GetEventInt(event, "userid");
	int client = GetClientOfUserId(userid);
	if (client == 0) return;
	
	bool isTempBot = g_isTempBot[client];
	if (isTempBot)
	{ g_isTempBot[client] = false; }
	
	if (!isTempBot) return;
	if ((!IsSurvivor(client) && !IsPassingSurvivor(client)) || !IsFakeClient(client)) return;
	
	CreateTimer(1.0, KickBot, userid, TIMER_FLAG_NO_MAPCHANGE);
}
Action KickBot(Handle timer, int client)
{
	client = GetClientOfUserId(client);
	if (client == 0 || !IsFakeClient(client)) return Plugin_Handled;
	KickClient(client);
	return Plugin_Handled;
}

Action Command_SpawnSurvBot(int client, int args)
{
	if (GetClientCount(false) >= MaxClients - 1)
	{
        return Plugin_Handled;
    }
	if (args > 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_survbot <char> <team>");
		return Plugin_Handled;
	}
	
	char argChar[4], argTeam[2];
	GetCmdArg(1, argChar, sizeof(argChar));
	GetCmdArg(2, argTeam, sizeof(argTeam));
	int argTeam_int = StringToInt(argTeam);
	//PrintToServer("argChar: %s, argTeam: %s", argChar, argTeam);
	int args_set[2];args_set = DetermineArgSelection_Cmd(argChar, argTeam_int);
	
	float origin[3], angles[3];
	origin = view_as<float>({0.0, 0.0, 0.0}); angles = view_as<float>({0.0, 0.0, 0.0});
	if (IsValidClient(client))
	{
		GetClientAbsOrigin(client, origin);
		GetClientAbsAngles(client, angles);
	}
	else
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (!IsValidClient(i, true, true) || !IsPlayerAlive(i) || (!IsSurvivor(i) && !IsPassingSurvivor(i))) continue;
			
			GetClientAbsOrigin(i, origin);
			GetClientAbsAngles(i, angles);
			break;
		}
	}
	
	int bot = CreateSurvivorBot(origin, angles, args_set[0], args_set[1]);
	if (bot != 0 && IsFakeClient(bot))
	{
		if (g_bTempBots)
		{
			g_isTempBot[bot] = true;
		}
		if (GetClientTeam(bot) == TEAM_PASSING)
		{
			SetVariantInt(0);
			AcceptEntityInput(bot, "SetGlowEnabled");
		}
	}
	return Plugin_Handled;
}

Action Command_SpawnFake(int client, int args)
{
	if (GetClientCount(false) >= MaxClients - 1)
	{
        return Plugin_Handled;
    }
	if (args > 2)
	{
		ReplyToCommand(client, "[SM] Usage: sm_fakebot <char> <team>");
		return Plugin_Handled;
	}
	
	char argChar[4], argTeam[2];
	GetCmdArg(1, argChar, sizeof(argChar));
	GetCmdArg(2, argTeam, sizeof(argTeam));
	int argTeam_int = StringToInt(argTeam);
	
	int args_set[2];args_set = DetermineArgSelection_Cmd(argChar, argTeam_int);
	
	float origin[3], angles[3];
	origin = view_as<float>({0.0, 0.0, 0.0}); angles = view_as<float>({0.0, 0.0, 0.0});
	if (IsValidClient(client))
	{
		GetClientAbsOrigin(client, origin);
		GetClientAbsAngles(client, angles);
	}
	else
	{
		for (int i = 1; i <= MaxClients; i++)
		{
			if (!IsValidClient(i, true, true) || !IsPlayerAlive(i) || (!IsSurvivor(i) && !IsPassingSurvivor(i))) continue;
			
			GetClientAbsOrigin(i, origin);
			GetClientAbsAngles(i, angles);
			break;
		}
	}
	
	int bot = CreateFakeClient("Bot");
	if (bot != 0)
	{
		ChangeClientTeam(bot, args_set[1]);
		if (args_set[1] == TEAM_SURVIVOR || args_set[1] == TEAM_PASSING)
		{
			SetSurvivorChar(bot, args_set[0], true);
		}
    }
	return Plugin_Handled;
}

int[] DetermineArgSelection_Cmd(const char[] charStr, int team, int survSet = SURVBOTS_PASSING_L4D1|SURVBOTS_L4D2)
{
	int charInt;
	// If charStr is empty then immediate -1
	if (charStr[0] != '\0')
	{
		// Try to find the letters first
		charInt = ConvertStrToSurvChar(charStr);
		if (charInt == -1) // If letters don't correspond to survivors...
		{
			charInt = StringToInt(charStr); // Convert string to int
			if (charInt == 0 && charStr[0] != '0') charInt = -1;
			// If the str is not a 0 as the int, change to -1
		}
	}
	else charInt = -1;
	
	int result[2];
	result = DetermineArgSelection(charInt, team, survSet);
	return result;
}

int[] DetermineArgSelection(int character, int team, int survSet = SURVBOTS_L4D2)
{
	int result[2];
	if (team != TEAM_SURVIVOR && team != TEAM_PASSING)
	{ result[1] = TEAM_SURVIVOR; }
	else
	{ result[1] = team; }
	
	// if charStr is empty or, charStr is not 0 and charInt is lesser than rochelle, but higher than louis then
	//if (charStr[0] == '\0' || (charStr[0] != '0' && (character < 1 || character > 7)))
	// if character is lesser than nick or higher than louis then do random
	if (character < 0 || character > 7)
	{
		bool allowL4D1 = view_as<bool>(survSet & SURVBOTS_L4D1);
		bool allowL4D2 = view_as<bool>(survSet & SURVBOTS_L4D2);
		bool allowPassing = view_as<bool>(survSet & SURVBOTS_PASSING_L4D1);
		if ((allowL4D1 || allowL4D2) && allowPassing)
		{ result[0] = GetRandomInt(0, 7); }
		else if (allowPassing)
		{ result[0] = GetRandomInt(4, 7); }
		else
		{ result[0] = GetRandomInt(0, 3); }
	}
	else
	{ result[0] = character; }
	return result;
}

// CreateSurvivorBot
void PreventSelect(int client)
{
	g_stored[client] = PREVENTSELECT_OFF;
	if (!IsValidClient(client, true, true) || (!IsSurvivor(client) && !IsPassingSurvivor(client))) return;
	
	int Prop = GetEntProp(client, Prop_Send, "m_survivorCharacter");
	if (Prop == 4)
	{
		g_stored[client] = PREVENTSELECT_ISBILL;
		SetEntProp(client, Prop_Send, "m_survivorCharacter", 1);
	}
	else if (Prop == 0)
	{
		g_stored[client] = PREVENTSELECT_ISNICK;
		SetEntProp(client, Prop_Send, "m_survivorCharacter", 1);
	}
	else
	{
		g_stored[client] = PREVENTSELECT_DEFAULT;
	}
}
void ReallowSelect(int client)
{
	bool isBill = (g_stored[client] == PREVENTSELECT_ISBILL);
	bool isNick = (g_stored[client] == PREVENTSELECT_ISNICK);
	g_stored[client] = PREVENTSELECT_OFF;
	
	if (!IsValidClient(client, true, true) || (!IsSurvivor(client) && !IsPassingSurvivor(client))) return;
	
	int Prop = GetEntProp(client, Prop_Send, "m_survivorCharacter");
	if (Prop == 1)
	{
		if (isBill)		SetEntProp(client, Prop_Send, "m_survivorCharacter", 4);
		else if (isNick)	SetEntProp(client, Prop_Send, "m_survivorCharacter", 0);
	}
}

int CreateSurvivorBot(const float origin[3], const float angles[3], int character = 4, int team = TEAM_SURVIVOR, int survSet = SURVBOTS_L4D2)
{
	int spawn = CreateEntityByName("info_l4d1_survivor_spawn");
	DispatchKeyValue(spawn, "character", "4");
	DispatchKeyValueVector(spawn, "origin", origin);
	DispatchKeyValueVector(spawn, "angles", angles);
	//DispatchKeyValue(spawn, "targetname", TRICKERY_SPAWNBOT_NAME);
	DispatchSpawn(spawn);
	ActivateEntity(spawn);
	AcceptEntityInput(spawn, "Kill");
	
	for (int i = 1; i <= MaxClients; i++)
	{ PreventSelect(i); }
	AcceptEntityInput(spawn, "SpawnSurvivor");
	
	int result = 0;
	//float spawn_origin[3];
	for (int i = 1; i <= MaxClients; i++)
	{
		if (!IsValidClient(i, true, true) || !IsPassingSurvivor(i) || !IsFakeClient(i)) continue;
		if (g_stored[i] != PREVENTSELECT_OFF) continue;
		
		//GetClientAbsOrigin(i, spawn_origin);
		
		//if (spawn_origin[0] == origin[0] && spawn_origin[1] == origin[1] && spawn_origin[2] == origin[2])
		//{
		result = i;
		//g_stored[i] = PREVENTSELECT_DEFAULT;
		break;
		//}
	}
	for (int i = 1; i <= MaxClients; i++)
	{ ReallowSelect(i); }
	
	if (result == 0 || !IsValidClient(result, false, true)) return 0;
	
	ChangeClientTeam(result, team);
	SetSurvivorChar(result, character, true, survSet);
	
	if (!IsPlayerAlive(result))
	{ RespawnSurvivor(result, origin, angles); }
	
	TeleportEntity(result, origin, angles, NULL_VECTOR);
	
	return result;
}
void RespawnSurvivor(int client, const float origin[3], const float angles[3])
{
	// We respawn the player via rescue entity; we don't need a signature at all!
	int rescue_ent = CreateEntityByName("info_survivor_rescue");
	if (!RealValidEntity(rescue_ent))
	{ return; }
	AcceptEntityInput(rescue_ent, "Kill");
	
	TeleportEntity(rescue_ent, origin, angles, NULL_VECTOR);
	
	char cl_model[PLATFORM_MAX_PATH];
	GetClientModel(client, cl_model, sizeof(cl_model));
	SetEntityModel(rescue_ent, cl_model);
	
	DispatchSpawn(rescue_ent);
	ActivateEntity(rescue_ent);
	
	DispatchKeyValue(rescue_ent, "nextthink", "10.0");
	
	SetEntPropEnt(rescue_ent, Prop_Send, "m_survivor", client);
	AcceptEntityInput(rescue_ent, "Rescue");
	
	SetEntityHealth(client, GetEntProp(client, Prop_Send, "m_iMaxHealth"));
}
//GENDER_NAMVET           =  3,
//GENDER_TEENGIRL         =  4,
//GENDER_BIKER            =  5,
//GENDER_MANAGER          =  6,
//GENDER_GAMBLER          =  7,
//GENDER_PRODUCER         =  8,
//GENDER_COACH            =  9,
//GENDER_MECHANIC         = 10,
void SetSurvivorChar(int client, int character, bool setMdl = false, int survSet = SURVBOTS_L4D2)
{
	int survOffset = character;
	if (view_as<bool>(survSet & SURVBOTS_L4D1))
	{
		if (character < 4)
		{
			survOffset += 4;
			switch (character)
			{
				case 2: // Coach, Louis to Coach
				{ survOffset += 1; } // 2 + 4 = 6	6 + 1 = 7
				case 3: // Ellis, Francis to Ellis
				{ survOffset -= 1; } // 3 + 4 = 7	7 - 1 = 6
				// Louis and Francis take place of Coach = 2 and Ellis = 3 on m_survivorCharacter
				// respectively, but Francis = 6 and Louis = 7 for the Passing team, 
				// hence this switch check.
			}
		}
	}
	
	if (IsFakeClient(client)) SetClientName(client, survivor_names[survOffset]);
	SetEntProp(client, Prop_Send, "m_survivorCharacter", character);
	if (!setMdl) return;
	
	// on second thought, gender isn't changed, f
	/*int gender = GetEntProp(client, Prop_Send, "m_Gender");
	if (character >= 0 && character <= 3 && gender != (7 + character))
	{
		switch (character)
		{
			case 0:
			{ character = 4; }
			case 1:
			{ character = 5; }
			case 2:
			{ character = 7; }
			case 3:
			{ character = 6; }
		}
	}*/
	
	char temp_str[PLATFORM_MAX_PATH+1];
	Format(temp_str, sizeof(temp_str), "models/survivors/survivor_%s.mdl", survivor_mdls[survOffset]);
	if (!IsModelPrecached(temp_str))
	{ PrecacheModel(temp_str); }
	SetEntityModel(client, temp_str);
}
// CreateSurvivorBot end

// Natives
public int CreateSurvivorBot_Hack(Handle plugin, int numParams)
{
	if (numParams < 1 || numParams > 4)
		ThrowNativeError(SP_ERROR_PARAM, "Invalid number of parameters!");
	
	float origin[3]/*, angles[3]*/;
	GetNativeArray(1, origin, sizeof(origin));
	//GetNativeArray(2, angles, sizeof(angles));
	
	//char argChar[4];
	//GetNativeString(2, argChar, sizeof(argChar));
	
	int argChar_int = GetNativeCell(2), argTeam_int = GetNativeCell(3), 
	argSurvSet_int = GetNativeCell(4);
	//PrintToServer("Native used!\norigin: %f %f %f\nargChar_int: %i\nargTeam_int: %i\nargSurvSet_int: %i", 
	//origin[0], origin[1], origin[2], argChar_int, argTeam_int, argSurvSet_int);
	
	int args_set[2];args_set = DetermineArgSelection(argChar_int, argTeam_int, argSurvSet_int);
	
	int bot = CreateSurvivorBot(origin, NULL_VECTOR, args_set[0], args_set[1], argSurvSet_int);
	return bot;
}
// Natives end

int ConvertStrToSurvChar(const char[] str)
{
	switch (CharToLower(str[0]))
	{
		case 'n': // Nick
		{ return 0; }
		case 'r': // Rochelle
		{ return 1; }
		case 'c': // Coach
		{ return 2; }
		case 'e': // Ellis
		{ return 3; }
		case 'b': // Bill
		{ return 4; }
		case 'z': // Zoey Bandicoot
		{ return 5; }
		case 'f': // Francis
		{ return 6; }
		case 'l': // Louis
		{ return 7; }
	}
	return -1;
}

stock bool IsSurvivor(int client)
{ return (GetClientTeam(client) == TEAM_SURVIVOR || GetClientTeam(client) == TEAM_PASSING); }

//stock bool IsGameSurvivor(int client)
//{ return (GetClientTeam(client) == TEAM_SURVIVOR); }

//stock bool IsInfected(int client)
//{ return (GetClientTeam(client) == 3); }

stock bool IsPassingSurvivor(int client)
{ return (GetClientTeam(client) == TEAM_PASSING); }

stock bool RealValidEntity(int entity)
{ return (entity > 0 && IsValidEntity(entity)); }

/*bool IsIncapacitated(int client, int hanging = 2)
{
	bool isIncap = view_as<bool>(GetEntProp(client, Prop_Send, "m_isIncapacitated"));
	bool isHanging = view_as<bool>(GetEntProp(client, Prop_Send, "m_isHangingFromLedge"));
	
	switch (hanging)
	{
		// if hanging is 2, don't care about hanging
		case 2:
			return (isIncap);
		// if 1, check for hanging too
		case 1:
			return (isIncap && isHanging);
		// otherwise, must just be incapped to return true
		case 0:
			return (isIncap && !isHanging);
	}
	return false;
}*/

stock bool IsValidClient(int client, bool replaycheck = true, bool isLoop = false)
{
	if ((isLoop || client > 0 && client <= MaxClients) && IsClientInGame(client))
	{
		if (HasEntProp(client, Prop_Send, "m_bIsCoaching")) // TF2, CSGO?
			if (view_as<bool>(GetEntProp(client, Prop_Send, "m_bIsCoaching"))) return false;
		if (replaycheck)
		{
			if (IsClientSourceTV(client) || IsClientReplay(client)) return false;
		}
		return true;
	}
	return false;
}

/*int GetInfectedAbility(int client)
{
	if (!IsInfected(client)) return -1;
	
	int ability_ent = -1;
	if (HasEntProp(client, Prop_Send, "m_customAbility"))
	{
		ability_ent = GetEntPropEnt(client, Prop_Send, "m_customAbility");
	}
	return ability_ent;
}*/